#!/bin/sh
# FB-AHA.sh
# Version 0.1.2
# ----------------------------------------------------------------------

script="FB-AHA"
Debugmsg=$Debugmsg"Script-Version          : $0 v0.1.2 \n"
Debugmsg=$Debugmsg"verwendbar mit          : FB.common v0.1.2 / FB.cfg v0.1.1 \n"
Debugmsg=$Debugmsg" \n"

# TR-064 aktivieren, Benützer mit User und Passwort anlegen


Debug="1"										# mit "0" deaktivieren, wenn nicht mehr benötigt
ADDONDIR="/usr/local/addons/cuxd"

#COMMON="FB.common"
COMMON="$ADDONDIR/user/FB.common"
source $COMMON


AHAURL="http://$IP/webservices/homeautoswitch.lua"
devicesFBAHA="$temp/FritzBox_$IP-devices_$script.xml"


#SID auslesen via TR064
location="http://$IP:49000/upnp/control/deviceconfig"
uri="urn:dslforum-org:service:DeviceConfig:1"
Action='X_AVM-DE_CreateUrlSID'
SoapParam='NewX_AVM-DE_UrlSID'
get_TR064
SID=$(printf $TR064_temp | cut -c 5- )

set_CUxD_temperature(){
	if [ "$1" != "" ] ; then
		Debugmsg=$Debugmsg"set_CUxD_temperature  $3/$2 $1  \n"
		Debugmsg=$Debugmsg"http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27CUxD.$2.SET_TEMPERATURE%27%29.State%28%22$1%22%29 \n"
		$cURL -s "http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27CUxD.$2.SET_TEMPERATURE%27%29.State%28%22$1%22%29"	
	else
		Debugmsg=$Debugmsg"$IP -> set_CUxD_temperature: $3/$2 - Fehler, keine Status.\n"
		logger -i -t $0 -p 3 "$IP -> set_CUxD_temperature: $3/$2 - Fehler, keine Status."
	fi
}

get_FBAHA_state(){ 		# 0 / 1 / inval
Debugmsg=$Debugmsg"URL: $AHAURL?ain=$AIN&switchcmd=getswitchstate&sid=$SID \n"	
stateFBAHA=$($cURL -s "$AHAURL?ain=$AIN&switchcmd=getswitchstate&sid=$SID")
}
get_FBAHA_present(){ 	# 0 / 1
Debugmsg=$Debugmsg"URL: $AHAURL?ain=$AIN&switchcmd=getswitchpresent&sid=$SID \n"	
presentFBAHA=$($cURL -s "$AHAURL?ain=$AIN&switchcmd=getswitchpresent&sid=$SID")
}
get_FBAHA_DEVICE_state(){
if [ -f $devicesFBAHA ]; then
	find $temp/ -name "FritzBox_$IP-devices_$script.xml" -mmin +2 -print0 | xargs -0 rm -f
	Debugmsg=$Debugmsg"$IP -> FBAHA: Daten pruefen \n"	
fi
if [ -f $devicesFBAHA ]; then
	Debugmsg=$Debugmsg"$IP -> FBAHA: Daten vorhanden \n"
else
	Debugmsg=$Debugmsg"$IP -> FBAHA: Daten holen ($AHAURL?&switchcmd=getdevicelistinfos&sid=$SID) \n"	
	echo -n $($cURL -s "$AHAURL?switchcmd=getdevicelistinfos&sid=$SID" | sed 's|[" ]||g' ) > $devicesFBAHA
fi
response_Name=$(sed -n "/deviceidentifier=$AIN/{s/.*<deviceidentifier=$AIN//;s/<\/device.*//;p;}" $devicesFBAHA | sed -n 's:.*<name>\(.*\)</name>.*:\1:p' )

get_FBAHA_Celsius=$(sed -n "/deviceidentifier=$AIN/{s/.*<deviceidentifier=$AIN//;s/<\/device.*//;p;}" $devicesFBAHA | sed -n 's:.*<celsius>\(.*\)</celsius>.*:\1:p' )
response_Celsius=$(printf "%.2i\n" $get_FBAHA_Celsius | sed -e "s:.$:.&:g")

get_FBAHA_Power=$(sed -n "/deviceidentifier=$AIN/{s/.*<deviceidentifier=$AIN//;s/<\/device.*//;p;}" $devicesFBAHA | sed -n 's:.*<power>\(.*\)</power>.*:\1:p' )
response_Power=$(printf "%.4i\n" $get_FBAHA_Power | sed -e "s:...$:.&:g")

Debugmsg=$Debugmsg"\nGeraet: $response_Name / $AIN \n\nPower: $get_FBAHA_Power = $response_Power Watt\nTemperatur: $get_FBAHA_Celsius = $response_Celsius °C\n"	
}


# Debug Setzte alle Parameter für Logfile
Debugmsg=$Debugmsg"Parameter SID           = $SID \n"
Debugmsg=$Debugmsg"Parameter Debug         = $DebugFile \n"
Debugmsg=$Debugmsg"Parameter devicesFBAHA  = $devicesFBAHA \n"


Debugmsg=$Debugmsg"INFO:  Befehl $1 $2 $3 $4 \n" # switch / ain / state / sysvar/cux
case $1 in
	"test")  		Debugmsg=$Debugmsg"test: erfolgreich\n"	
					;;
	"switch")  		AIN=$2
					if [ $3 = "0" ] ; then
						$cURL -s "$AHAURL?ain=$AIN&switchcmd=setswitchoff&sid=$SID"
						Debugmsg=$Debugmsg"$AHAURL?ain=$AIN&switchcmd=setswitchoff&sid=$SID\n"
					elif [ $3 = "1" ] ; then
						$cURL -s "$AHAURL?ain=$AIN&switchcmd=setswitchon&sid=$SID"
						Debugmsg=$Debugmsg"$AHAURL?ain=$AIN&switchcmd=setswitchon&sid=$SID\n"
					elif [ $3 = "state" ] ; then
						get_FBAHA_state
						set_CUxD_state $stateFBAHA $4 $1
					elif [ $3 = "state1" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state $stateFBAHA $4 $1
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							set_CCU_SysVar $presentFBAHA $4-Status $1
						else
							presentFBAHA=2
							set_CCU_SysVar $presentFBAHA $4-Status $1
						fi
					elif [ $3 = "state1-p" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state $stateFBAHA $4 $1
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							set_CCU_SysVar $presentFBAHA $4-Status $1
						else
							presentFBAHA=2
							set_CCU_SysVar $presentFBAHA $4-Status $1
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Power != "" ] ; then
							set_CCU_SysVar $response_Power $4-Leistung $1
						else
							set_CCU_SysVar "" $4-Leistung $1
						fi
					elif [ $3 = "state1-t" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state $stateFBAHA $4 $1
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							set_CCU_SysVar $presentFBAHA $4-Status $1
						else
							presentFBAHA=2
							set_CCU_SysVar $presentFBAHA $4-Status $1
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							set_CCU_SysVar $response_Celsius $4-Temperatur $1
						else
							set_CCU_SysVar "" $4-Temperatur $1
						fi
					elif [ $3 = "state1-pt" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state $stateFBAHA $4 $1
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							set_CCU_SysVar $presentFBAHA $4-Status $1
						else
							presentFBAHA=2
							set_CCU_SysVar $presentFBAHA $4-Status $1
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							set_CCU_SysVar $response_Celsius $4-Temperatur $1
						else
							set_CCU_SysVar "" $4-Temperatur $1
						fi
						if [ $get_FBAHA_Power != "" ] ; then
							set_CCU_SysVar $response_Power $4-Leistung $1
						else
							set_CCU_SysVar "" $4-Leistung $1
						fi
					elif [ $3 = "state1-pts" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state $stateFBAHA $4 $1
						if [ $stateFBAHA != "" ] ; then
							set_CCU_SysVar $stateFBAHA $4-Schaltzustand $1
						else
							set_CCU_SysVar "" $4-Schaltzustand $1
						fi
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							set_CCU_SysVar $presentFBAHA $4-Status $1
						else
							presentFBAHA=2
							set_CCU_SysVar $presentFBAHA $4-Status $1
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							set_CCU_SysVar $response_Celsius $4-Temperatur $1
						else
							set_CCU_SysVar "" $4-Temperatur $1
						fi
						if [ $get_FBAHA_Power != "" ] ; then
							set_CCU_SysVar $response_Power $4-Leistung $1
						else
							set_CCU_SysVar "" $4-Leistung $1
						fi
					elif [ $3 = "power" ] ; then 
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Power != "" ] ; then
							set_CCU_SysVar $response_Power $4-Leistung $1
						else
							set_CCU_SysVar "" $4-Leistung $1
						fi
					elif [ $3 = "power1" ] ; then 
						get_FBAHA_DEVICE_state
						set_CUxD_state $get_FBAHA_Power $4 $1
					elif [ $3 = "temperature" ] ; then 
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							set_CCU_SysVar $response_Celsius $4-Temperatur $1
						else
							set_CCU_SysVar "" $4-Temperatur $1
						fi
					elif [ $3 = "temperature1" ] ; then 
						get_FBAHA_DEVICE_state
						set_CUxD_state $get_FBAHA_Celsius $4 $1
					elif [ $3 = "temperature2" ] ; then 
						get_FBAHA_DEVICE_state
						set_CUxD_temperature $get_FBAHA_Celsius $4 $1
					else
					logger -i -t $0 -p 3 "$IP -> $1: Fehler"
					fi
					;;

	*) 				Debugmsg=$Debugmsg"MAIN :  ERROR - Bitte wie folgt aufrufen: \n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh BEFEHL WERT (0=aus|1=ein) \n"
					Debugmsg=$Debugmsg"        Verfuegbar:  \n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state CUX2801xxx:x] -> ein/aus an das sendende Gerät\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state CUX9001xxx:x] -> ein/aus an CUxD (90)State-Monitor Device\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state1 CUX2801xxx:x] - SysVar [CUX2801xxx:x-Status] -> Werteliste: nicht erreichbar;erreichbar;unbekannt\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state1-p CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status] [CUX2801xxx:x-Leistung]\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state1-t CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status]  [CUX2801xxx:x-Temperatur]\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state1-pt CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status] [CUX2801xxx:x-Leistung] [CUX2801xxx:x-Temperatur]\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|state1-pts CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status] [CUX2801xxx:x-Leistung] [CUX2801xxx:x-Temperatur] [CUX2801xxx:x-Schaltzustand]\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|power CUX2801xxx:x] - SysVar [CUX2801xxx:x-Leistung] -> Zahl\n"
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|power1 CUX9000xxx:x] - CUxD (90)Transform Device \n"	
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|temperature CUX2801xxx:x] - SysVar [CUX2801xxx:x-Temperatur] -> Zahl\n"		
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|temperature1 CUX9000xxx:x] - CUxD (90)Transform Device \n"	
					Debugmsg=$Debugmsg"        ./FB-AHA.sh switch [AIN|MAC] [0|1|temperature2 CUX9002xxx:x] - CUxD (90)Thermostat Device \n"

					EndFritzBoxSkript 4 "Falscher-Parameter-Aufruf-$1-$2-$3-$4";;
esac
EndFritzBoxSkript 0 "Erfolgreich"
